unit Comps;

interface
uses
  Classes, Messages, Windows, StdCtrls, ExtCtrls, Graphics, Forms,
  //
  stdGraphics, ChoiLabels;
type
  TTWatchLabel = class(TThreeLabel)
  private
    { Private 錾}
  protected
    { Protected 錾 }
    procedure DoDrawText(var Rect: TRect; Flags: Integer); override;
    procedure WMLButtonDown(var Message: TWMLButtonDown);
      message WM_LBUTTONDOWN;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  end;

  TTWatchPanel = class(TPanel)
  private
    { Private 錾 }
    FBackground : TPicture;
    FOnPaint    : TNotifyEvent;
  protected
    { Protected 錾 }
    procedure Paint; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property  Background: TPicture      read  FBackground;
    property  OnPaint   : TNotifyEvent  read  FOnPaint;
  end;

implementation

uses Controls;

{ TTWatchLabel }

constructor TTWatchLabel.Create(AOwner: TComponent);
begin
  inherited;
  Self.BevelWidth := 0;
end;

procedure TTWatchLabel.DoDrawText(var Rect: TRect; Flags: Integer);
begin
  inherited;
end;

procedure TTWatchLabel.WMLButtonDown(var Message: TWMLButtonDown);
begin
  inherited;
  ReleaseCapture;
  PostMessage(Parent.Parent.Handle, WM_NCLBUTTONDOWN, HTCAPTION, Integer(Message.Pos));
end;

{ TTWatchPanel }

constructor TTWatchPanel.Create(AOwner: TComponent);
begin
  inherited;
  FBackground := TPicture.Create;
end;

destructor TTWatchPanel.Destroy;
begin
  Background.Free;
  inherited;
end;

procedure TTWatchPanel.Paint;
begin
  inherited;
  TileBitmap(ClientRect, Canvas, Background.Bitmap);
  if Assigned(OnPaint) then OnPaint(Self);
end;

end.
